/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * Paths
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestParameterizedCustomHostTestClient.
 */
export interface Paths {

    /**
     * Get a 200 to test a valid base uri
     *
     * @param {string} vault The vault name, e.g. https://myvault
     * 
     * @param {string} secret Secret value.
     * 
     * @param {string} keyName The key name with value 'key1'.
     * 
     * @param {object} [options] Optional Parameters.
     * 
     * @param {string} [options.keyVersion] The key version. Default value 'v1'.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getEmpty(vault: string, secret: string, keyName: string, options: { keyVersion? : string, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getEmpty(vault: string, secret: string, keyName: string, callback: ServiceCallback<void>): void;
}
